module Main where

import System.Directory
import Options.Applicative
import Data.List

success :: String
success = "20 text/gemini; lang=en; charset=utf-8\r\n"

data Args = Args
    { title :: String
    , directory :: FilePath
    , fileHead :: FilePath
    , verbose :: Bool
    , cgi :: Bool
    }

args :: Parser Args
args = Args
    <$> strOption
          ( long "title"
        <> short 't'
        <> value "Title Left Blank"
        <> help "Document title" )
    <*> strOption
        ( long "directory"
       <> short 'd'
       <> value "./"
       <> help "Directory to parse" )
    <*> strOption
        ( long "header"
       <> short 'H'
       <> value ""
       <> help "Header text" )
    <*> switch
        ( long "verbose"
       <> short 'v'
       <> help "Verbose mode")
    <*> switch
        ( long "cgi"
       <> help "Output gemini file header")

main :: IO ()
main = parseArgs =<< execParser opts
  where
    opts = info ( args <**> helper)
        ( fullDesc
       <> progDesc "Generate  gemini page index"
       <> header "Generate a gemini page index")

parseArgs :: Args -> IO()
parseArgs (Args t d h False False) = do
    putStrLn $ "# " ++ t
    putStrLn h
    mkIndex =<< getDirectoryContents d
parseArgs (Args t d h False True) = do
    putStr success
    putStrLn $ "# " ++ t
    putStrLn h
    mkIndex =<< getDirectoryContents d
parseArgs _ = putStrLn "fiets"

mkIndex :: [String] -> IO ()
mkIndex = mapM_ (putStrLn . ("=> " ++)) . filter (isSuffixOf ".gmi")
